C 20/03/97                                                      DWBA98  YFAS-000
      SUBROUTINE YFAS(ETA,RAU,FO,FPO,GO,GPO,SIGO)                       YFAS-001
C     ASYMPTOTIC EXPANSION. SAME ARGUMENTS AS FCZ0 EXCEPT FOR IEXP.     YFAS-002
      IMPLICIT REAL*8 (A-H,O-Z)                                         YFAS-003
      TRB=0.D0                                                          YFAS-004
      RAU2=RAU+RAU                                                      YFAS-005
      ETAC=ETA*ETA                                                      YFAS-006
      N=0                                                               YFAS-007
      PS=1.D0                                                           YFAS-008
      GS=0.D0                                                           YFAS-009
      PT=0.D0                                                           YFAS-010
      GT=1.D0-ETA/RAU                                                   YFAS-011
      SF=PS                                                             YFAS-012
      SG=GS                                                             YFAS-013
      SPF=PT                                                            YFAS-014
      SPG=GT                                                            YFAS-015
    1 DENOM=(N+1)*RAU2                                                  YFAS-016
      AN=(N+N+1)*ETA/DENOM                                              YFAS-017
      BN=(ETAC-N*(N+1))/DENOM                                           YFAS-018
      PS1=AN*PS-BN*PT                                                   YFAS-019
      GS1=AN*GS-BN*GT-PS1/RAU                                           YFAS-020
      PT1=AN*PT+BN*PS                                                   YFAS-021
      GT1=AN*GT+BN*GS-PT1/RAU                                           YFAS-022
      SF=SF+PS1                                                         YFAS-023
      SG=SG+GS1                                                         YFAS-024
      SPF=SPF+PT1                                                       YFAS-025
      SPG=SPG+GT1                                                       YFAS-026
      N=N+1                                                             YFAS-027
      IF (DABS(PS1).GT.TRB) TRB=DABS(PS1)                               YFAS-028
      IF (DABS(PS1).LT.1.D-10*TRB.OR.BN.LT.-1.D0) GO TO 2               YFAS-029
      PS=PS1                                                            YFAS-030
      GS=GS1                                                            YFAS-031
      PT=PT1                                                            YFAS-032
      GT=GT1                                                            YFAS-033
      GO TO 1                                                           YFAS-034
    2 TETAO=RAU-ETA*DLOG(RAU2)+SIGO                                     YFAS-035
      TRA=DSIN(TETAO)                                                   YFAS-036
      TRB=DCOS(TETAO)                                                   YFAS-037
      GO=SF*TRB-SPF*TRA                                                 YFAS-038
      GPO=SG*TRB-SPG*TRA                                                YFAS-039
      FO=SPF*TRB+SF*TRA                                                 YFAS-040
      FPO=SPG*TRB+SG*TRA                                                YFAS-041
      RETURN                                                            YFAS-042
      END                                                               YFAS-043
