C 20/03/97                                                      DWBA98  PSI -000
      FUNCTION PSI(ETA)                                                 PSI -001
C  REAL PART OF PSI(1-I*ETA)-PSI(1)-PSI(I)                              PSI -002
C  WITH PSI(Z) = LOGARITHMIC DERIVATIVE OF THE GAMMA FUNCTION           PSI -003
      DOUBLE PRECISION PSI,E,ETA,X,Y,C,C1,C2,C3,C4,C5,C6,B(13)          PSI -004
      DATA C/.5772156649015329D0/,C1/8.333333333333333D-2/,C2/-8.3333333PSI -005
     133333333D-3/,C3/3.968253968253968D-3/,C4/-4.166666666666667D-3/,C5PSI -006
     2/7.575757575757576D-3/,C6/-2.109279609279609D-2/,B/7.4507117898354PSI -007
     328D-9,2.980350351465228D-8,1.192199259653110D-7,4.769329867878064DPSI -008
     4-7,1.908212716553938D-6,7.637197637899762D-6,3.058823630702049D-5,PSI -009
     51.227133475784893D-4,4.941886041194665D-4,2.008392826082234D-3,8.3PSI -010
     649277381922945D-3,3.692775514337036D-2,2.020569031595948D-1/      PSI -011
      IF (DABS(ETA).GT.1.D-8) GO TO 1                                   PSI -012
      PSI=C-1.D0                                                        PSI -013
      GO TO 5                                                           PSI -014
    1 E=ETA*ETA                                                         PSI -015
      IF (E.GT..25D0) GO TO 3                                           PSI -016
      X=B(1)                                                            PSI -017
      DO 2 I=2,13                                                       PSI -018
    2 X=B(I)-E*X                                                        PSI -019
      PSI=C-1.D0/(1.D0+E)+E*X                                           PSI -020
      GO TO 5                                                           PSI -021
    3 L=1                                                               PSI -022
      IF (E.LT.64.D0) L=2.D0+DSQRT(64.D0-E)                             PSI -023
      X=DSQRT(L*L+E)                                                    PSI -024
      Y=DATAN(ETA/L)                                                    PSI -025
      E=1.D0/(L*L+E)                                                    PSI -026
      PSI=DLOG(X)-.5D0*L*E-E*(C1*DCOS(2*Y)+E*(C2*DCOS(4*Y)+E*(C3*DCOS(6*PSI -027
     1Y)+E*(C4*DCOS(8*Y)+E*(C5*DCOS(10*Y)+E*(C6*DCOS(12*Y)+E*C1*DCOS(14*PSI -028
     2Y)))))))+C+C-1.D0                                                 PSI -029
      IF (L.EQ.1) GO TO 5                                               PSI -030
      J=L-1                                                             PSI -031
      E=ETA*ETA                                                         PSI -032
      DO 4 I=1,J                                                        PSI -033
    4 PSI=PSI-1.D0/(I+E/I)                                              PSI -034
    5 RETURN                                                            PSI -035
      END                                                               PSI -036
